ZET = {Build = {}, Interface = {Mouse = {}, Temp = {}, Quests = {}}, Sync = {},  Data = {}, Lang = Inspect.System.Language(), User = Inspect.Unit.Detail("player"), Shard = Inspect.Shard(),}

function ZET.Build.Engine()
	local Broadcast, Register, Accept = Command.Message.Broadcast, Command.Event.Attach, Command.Message.Accept
	local Quest = Inspect.Quest.Detail
	local Pairs, Match = pairs, string.match
	local E, G = ZET, ZET.Globals
	if E.Online == "true" then return print("Online") end
	
	function E.Receive(Debug, From, Type, Channel, Id, Data)
		if (Id == G.Identifier) and (From ~= E.User.name) then
		
			if Match(Data, "Name<") then
				if not E.Sync[Match(Data, "Name<(.-)>")] then
					E.Sync[From] = 0
				end
			end
			
			if Match(Data, "ID<") then
				if E.Interface.Quests[Match(Data, "ID<(.-)>")] and Match(Data, "Stat<1>") and Match(Data, "Version<" .. G.Version .. ">") then
					E.Interface.Quests[Match(Data, "ID<(.-)>")] = {Name = Match(Data, "Name<(.-)>"), Action = " - ", Zone = Match(Data, "Zone<(.-)>"), Shard = "@" .. Match(Data, "Shard<(.-)>")}
					Broadcast("guild", nil, "ZET", "Name<" .. E.User.name .. ">")
					Broadcast("party", nil, "ZET", "Name<" .. E.User.name .. ">")
					Broadcast("raid", nil, "ZET", "Name<" .. E.User.name .. ">")
					Broadcast("yell", nil, "ZET", "Name<" .. E.User.name .. ">")
					Broadcast("say", nil, "ZET", "Name<" .. E.User.name .. ">")
					Broadcast("channel", ZET.Shards[E.Shard.name], "ZET", "Name<" .. E.User.name .. ">")
				end
				
				if not E.Interface.Quests[Match(Data, "ID<(.-)>")] and Match(Data, "Stat<1>") and Match(Data, "Version<" .. G.Version .. ">") then
					E.Interface.Quests[Match(Data, "ID<(.-)>")] = {Name = Match(Data, "Name<(.-)>"), Action = " - ", Zone = Match(Data, "Zone<(.-)>"), Shard = "@" .. Match(Data, "Shard<(.-)>")}
					Broadcast("guild", nil, "ZET", "Name<" .. E.User.name .. ">")
					Broadcast("party", nil, "ZET", "Name<" .. E.User.name .. ">")
					Broadcast("raid", nil, "ZET", "Name<" .. E.User.name .. ">")
					Broadcast("yell", nil, "ZET", "Name<" .. E.User.name .. ">")
					Broadcast("say", nil, "ZET", "Name<" .. E.User.name .. ">")
					Broadcast("channel", ZET.Shards[E.Shard.name], "ZET", "Name<" .. E.User.name .. ">")
				end
				
				if E.Interface.Quests[Match(Data, "ID<(.-)>")] and Match(Data, "Stat<0>") and Match(Data, "Version<" .. G.Version .. ">") then
					E.Interface.Quests[Match(Data, "ID<(.-)>")] = O
				end
			end
		elseif (Id ~= G.Identifier) or (From == E.User.name) then
		return end
	end
	
	function E.Accept(Debug, EAcceptInput)
	
		for k,v in Pairs(EAcceptInput) do
		
			if E.QuestsList[k] then
				local QD = Quest(k)
				
				E.Player = Inspect.Unit.Detail("player")

				E.Zone = Inspect.Zone.Detail(E.Player.zone)
				
				if E.newShardName then
					E.newShardName = nil
				end
				
				if E.ShardName then
					E.ShardName = nil
				end
				
				E.Consolas = Inspect.Console.List()
				for cid, flag in Pairs(E.Consolas) do
					E.Consola = Inspect.Console.Detail(cid)

					if E.Consola.channel then
						for cname, flag in Pairs(E.Consola.channel) do
							if cname == E.Zone.name then
								E.newShardName = E.Shard and E.Shard.name
							elseif (cname:sub(1, E.Zone.name:len()+1) == E.Zone.name.."@") then
								E.newShardName = cname:sub(E.Zone.name:len()+2)
							end
						end
					end
				end
				if E.newShardName and E.newShardName ~= E.ShardName then
					E.ShardName = E.newShardName
				end
				
				if E.ShardName ~= nil then
					if not E.Interface.Quests[k] then
						E.Interface.Quests[k] = {Name = QD.name, Action = " - ", Zone = QD.categoryName, Shard = "@" .. E.ShardName,}
					end
					
					E.Send("ID<" .. QD.id .. ">Stat<1>Name<" .. QD.name .. ">Zone<" .. QD.categoryName .. ">Shard<" .. E.ShardName .. ">Version<" .. G.Version .. ">")
				end
			end			
		end
	end
	
	function E.Complete(Debug, ECompleteInput)
		
		for k,v in Pairs(ECompleteInput) do
			if E.QuestsList[k] then
				local QD = Quest(k)

				if E.Interface.Quests[k] then
					E.Interface.Quests[k] = O
				end

				E.Player = Inspect.Unit.Detail("player")

				E.Zone = Inspect.Zone.Detail(E.Player.zone)
				
				if E.newShardName then
					E.newShardName = nil
				end
				
				if E.ShardName then
					E.ShardName = nil
				end
				
				E.Consolas = Inspect.Console.List()
				for cid, flag in Pairs(E.Consolas) do
					E.Consola=Inspect.Console.Detail(cid)

					if E.Consola.channel then
						for cname, flag in Pairs(E.Consola.channel) do
							if cname == E.Zone.name then
								E.newShardName = E.Shard and E.Shard.name
							elseif (cname:sub(1, E.Zone.name:len()+1) == E.Zone.name.."@") then
								E.newShardName = cname:sub(E.Zone.name:len()+2)
							end
						end
					end
				end
				if E.newShardName and E.newShardName ~= E.ShardName then
					E.ShardName = E.newShardName
				end
				
				if E.ShardName ~= nil then
					if E.Interface.Quests[k] then
						E.Interface.Quests[k] = O
					end
					
					E.Send("ID<" .. QD.id .. ">Stat<0>Name<" .. QD.name .. ">Zone<" .. QD.categoryName .. ">Shard<" .. E.ShardName .. ">Version<" .. G.Version .. ">")
				end
			end			
		end
	end
	
	function E.Send(ESendInput)
		local Send = Command.Message.Send
		
		for k,v in Pairs(E.Sync) do
			Send(k, "ZET", ESendInput, tostring)
		end
	end
	
	Accept(nil, "ZET")
	Register(Event.Message.Receive, E.Receive, "ZET Receive")
	Register(Event.Quest.Accept, E.Accept, "ZET Quest Accept")
	Register(Event.Quest.Complete, E.Complete, "ZET Quest Complete")
	E.Online = "true"
end