	local G, E = ZET.Globals, ZET
	local Broadcast, Accept, Attach = Command.Message.Broadcast, Command.Message.Accept, Command.Event.Attach

function ZET.Load(Debug, Input)
	if ZET.Online then return end
	
	if Input == "ZET" then
		
		print(G.Name[E.Lang] .. " : " .. G.Version)
		
		Accept(nil, "ZET")
		Broadcast("guild", nil, "ZET", "Name<" .. E.User.name .. ">")
		Broadcast("party", nil, "ZET", "Name<" .. E.User.name .. ">")
		Broadcast("raid", nil, "ZET", "Name<" .. E.User.name .. ">")
		Broadcast("yell", nil, "ZET", "Name<" .. E.User.name .. ">")
		Broadcast("say", nil, "ZET", "Name<" .. E.User.name .. ">")
		Broadcast("channel", ZET.Shards[E.Shard.name], "ZET", "Name<" .. E.User.name .. ">")
		
		ZET.Build.Engine()
		ZET.Build.Interface()
		ZET.Online = true
	end
end

Attach(Event.Addon.Load.End, ZET.Load, "Load")

--Event.Quest.Accept(elements)
--Event.Quest.Complete